//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: juno/mint/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query provides defines the gRPC querier service.
///
/// Usage: instantiate `CosmosContracts_Juno_Mint_QueryClient`, then call methods of this protocol to make API calls.
internal protocol CosmosContracts_Juno_Mint_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: CosmosContracts_Juno_Mint_QueryClientInterceptorFactoryProtocol? { get }

  func params(
    _ request: CosmosContracts_Juno_Mint_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<CosmosContracts_Juno_Mint_QueryParamsRequest, CosmosContracts_Juno_Mint_QueryParamsResponse>

  func inflation(
    _ request: CosmosContracts_Juno_Mint_QueryInflationRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<CosmosContracts_Juno_Mint_QueryInflationRequest, CosmosContracts_Juno_Mint_QueryInflationResponse>

  func annualProvisions(
    _ request: CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest, CosmosContracts_Juno_Mint_QueryAnnualProvisionsResponse>
}

extension CosmosContracts_Juno_Mint_QueryClientProtocol {
  internal var serviceName: String {
    return "CosmosContracts.juno.mint.Query"
  }

  /// Params returns the total set of minting parameters.
  ///
  /// - Parameters:
  ///   - request: Request to send to Params.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func params(
    _ request: CosmosContracts_Juno_Mint_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<CosmosContracts_Juno_Mint_QueryParamsRequest, CosmosContracts_Juno_Mint_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/CosmosContracts.juno.mint.Query/Params",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeParamsInterceptors() ?? []
    )
  }

  /// Inflation returns the current minting inflation value.
  ///
  /// - Parameters:
  ///   - request: Request to send to Inflation.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func inflation(
    _ request: CosmosContracts_Juno_Mint_QueryInflationRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<CosmosContracts_Juno_Mint_QueryInflationRequest, CosmosContracts_Juno_Mint_QueryInflationResponse> {
    return self.makeUnaryCall(
      path: "/CosmosContracts.juno.mint.Query/Inflation",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeInflationInterceptors() ?? []
    )
  }

  /// AnnualProvisions current minting annual provisions value.
  ///
  /// - Parameters:
  ///   - request: Request to send to AnnualProvisions.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func annualProvisions(
    _ request: CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest, CosmosContracts_Juno_Mint_QueryAnnualProvisionsResponse> {
    return self.makeUnaryCall(
      path: "/CosmosContracts.juno.mint.Query/AnnualProvisions",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAnnualProvisionsInterceptors() ?? []
    )
  }
}

internal protocol CosmosContracts_Juno_Mint_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'params'.
  func makeParamsInterceptors() -> [ClientInterceptor<CosmosContracts_Juno_Mint_QueryParamsRequest, CosmosContracts_Juno_Mint_QueryParamsResponse>]

  /// - Returns: Interceptors to use when invoking 'inflation'.
  func makeInflationInterceptors() -> [ClientInterceptor<CosmosContracts_Juno_Mint_QueryInflationRequest, CosmosContracts_Juno_Mint_QueryInflationResponse>]

  /// - Returns: Interceptors to use when invoking 'annualProvisions'.
  func makeAnnualProvisionsInterceptors() -> [ClientInterceptor<CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest, CosmosContracts_Juno_Mint_QueryAnnualProvisionsResponse>]
}

internal final class CosmosContracts_Juno_Mint_QueryClient: CosmosContracts_Juno_Mint_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: CosmosContracts_Juno_Mint_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the CosmosContracts.juno.mint.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: CosmosContracts_Juno_Mint_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query provides defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol CosmosContracts_Juno_Mint_QueryProvider: CallHandlerProvider {
  var interceptors: CosmosContracts_Juno_Mint_QueryServerInterceptorFactoryProtocol? { get }

  /// Params returns the total set of minting parameters.
  func params(request: CosmosContracts_Juno_Mint_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<CosmosContracts_Juno_Mint_QueryParamsResponse>

  /// Inflation returns the current minting inflation value.
  func inflation(request: CosmosContracts_Juno_Mint_QueryInflationRequest, context: StatusOnlyCallContext) -> EventLoopFuture<CosmosContracts_Juno_Mint_QueryInflationResponse>

  /// AnnualProvisions current minting annual provisions value.
  func annualProvisions(request: CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<CosmosContracts_Juno_Mint_QueryAnnualProvisionsResponse>
}

extension CosmosContracts_Juno_Mint_QueryProvider {
  internal var serviceName: Substring { return "CosmosContracts.juno.mint.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Params":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<CosmosContracts_Juno_Mint_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<CosmosContracts_Juno_Mint_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeParamsInterceptors() ?? [],
        userFunction: self.params(request:context:)
      )

    case "Inflation":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<CosmosContracts_Juno_Mint_QueryInflationRequest>(),
        responseSerializer: ProtobufSerializer<CosmosContracts_Juno_Mint_QueryInflationResponse>(),
        interceptors: self.interceptors?.makeInflationInterceptors() ?? [],
        userFunction: self.inflation(request:context:)
      )

    case "AnnualProvisions":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest>(),
        responseSerializer: ProtobufSerializer<CosmosContracts_Juno_Mint_QueryAnnualProvisionsResponse>(),
        interceptors: self.interceptors?.makeAnnualProvisionsInterceptors() ?? [],
        userFunction: self.annualProvisions(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol CosmosContracts_Juno_Mint_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'params'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeParamsInterceptors() -> [ServerInterceptor<CosmosContracts_Juno_Mint_QueryParamsRequest, CosmosContracts_Juno_Mint_QueryParamsResponse>]

  /// - Returns: Interceptors to use when handling 'inflation'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeInflationInterceptors() -> [ServerInterceptor<CosmosContracts_Juno_Mint_QueryInflationRequest, CosmosContracts_Juno_Mint_QueryInflationResponse>]

  /// - Returns: Interceptors to use when handling 'annualProvisions'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAnnualProvisionsInterceptors() -> [ServerInterceptor<CosmosContracts_Juno_Mint_QueryAnnualProvisionsRequest, CosmosContracts_Juno_Mint_QueryAnnualProvisionsResponse>]
}
