//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: sentinel/node/v1/querier.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Usage: instantiate `Sentinel_Node_V1_QueryServiceClient`, then call methods of this protocol to make API calls.
internal protocol Sentinel_Node_V1_QueryServiceClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Sentinel_Node_V1_QueryServiceClientInterceptorFactoryProtocol? { get }

  func queryNodes(
    _ request: Sentinel_Node_V1_QueryNodesRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Sentinel_Node_V1_QueryNodesRequest, Sentinel_Node_V1_QueryNodesResponse>

  func queryNodesForProvider(
    _ request: Sentinel_Node_V1_QueryNodesForProviderRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Sentinel_Node_V1_QueryNodesForProviderRequest, Sentinel_Node_V1_QueryNodesForProviderResponse>

  func queryNode(
    _ request: Sentinel_Node_V1_QueryNodeRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Sentinel_Node_V1_QueryNodeRequest, Sentinel_Node_V1_QueryNodeResponse>

  func queryParams(
    _ request: Sentinel_Node_V1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Sentinel_Node_V1_QueryParamsRequest, Sentinel_Node_V1_QueryParamsResponse>
}

extension Sentinel_Node_V1_QueryServiceClientProtocol {
  internal var serviceName: String {
    return "sentinel.node.v1.QueryService"
  }

  /// Unary call to QueryNodes
  ///
  /// - Parameters:
  ///   - request: Request to send to QueryNodes.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func queryNodes(
    _ request: Sentinel_Node_V1_QueryNodesRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Sentinel_Node_V1_QueryNodesRequest, Sentinel_Node_V1_QueryNodesResponse> {
    return self.makeUnaryCall(
      path: "/sentinel.node.v1.QueryService/QueryNodes",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeQueryNodesInterceptors() ?? []
    )
  }

  /// Unary call to QueryNodesForProvider
  ///
  /// - Parameters:
  ///   - request: Request to send to QueryNodesForProvider.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func queryNodesForProvider(
    _ request: Sentinel_Node_V1_QueryNodesForProviderRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Sentinel_Node_V1_QueryNodesForProviderRequest, Sentinel_Node_V1_QueryNodesForProviderResponse> {
    return self.makeUnaryCall(
      path: "/sentinel.node.v1.QueryService/QueryNodesForProvider",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeQueryNodesForProviderInterceptors() ?? []
    )
  }

  /// Unary call to QueryNode
  ///
  /// - Parameters:
  ///   - request: Request to send to QueryNode.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func queryNode(
    _ request: Sentinel_Node_V1_QueryNodeRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Sentinel_Node_V1_QueryNodeRequest, Sentinel_Node_V1_QueryNodeResponse> {
    return self.makeUnaryCall(
      path: "/sentinel.node.v1.QueryService/QueryNode",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeQueryNodeInterceptors() ?? []
    )
  }

  /// Unary call to QueryParams
  ///
  /// - Parameters:
  ///   - request: Request to send to QueryParams.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func queryParams(
    _ request: Sentinel_Node_V1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Sentinel_Node_V1_QueryParamsRequest, Sentinel_Node_V1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/sentinel.node.v1.QueryService/QueryParams",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeQueryParamsInterceptors() ?? []
    )
  }
}

internal protocol Sentinel_Node_V1_QueryServiceClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'queryNodes'.
  func makeQueryNodesInterceptors() -> [ClientInterceptor<Sentinel_Node_V1_QueryNodesRequest, Sentinel_Node_V1_QueryNodesResponse>]

  /// - Returns: Interceptors to use when invoking 'queryNodesForProvider'.
  func makeQueryNodesForProviderInterceptors() -> [ClientInterceptor<Sentinel_Node_V1_QueryNodesForProviderRequest, Sentinel_Node_V1_QueryNodesForProviderResponse>]

  /// - Returns: Interceptors to use when invoking 'queryNode'.
  func makeQueryNodeInterceptors() -> [ClientInterceptor<Sentinel_Node_V1_QueryNodeRequest, Sentinel_Node_V1_QueryNodeResponse>]

  /// - Returns: Interceptors to use when invoking 'queryParams'.
  func makeQueryParamsInterceptors() -> [ClientInterceptor<Sentinel_Node_V1_QueryParamsRequest, Sentinel_Node_V1_QueryParamsResponse>]
}

internal final class Sentinel_Node_V1_QueryServiceClient: Sentinel_Node_V1_QueryServiceClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Sentinel_Node_V1_QueryServiceClientInterceptorFactoryProtocol?

  /// Creates a client for the sentinel.node.v1.QueryService service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Sentinel_Node_V1_QueryServiceClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// To build a server, implement a class that conforms to this protocol.
internal protocol Sentinel_Node_V1_QueryServiceProvider: CallHandlerProvider {
  var interceptors: Sentinel_Node_V1_QueryServiceServerInterceptorFactoryProtocol? { get }

  func queryNodes(request: Sentinel_Node_V1_QueryNodesRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Sentinel_Node_V1_QueryNodesResponse>

  func queryNodesForProvider(request: Sentinel_Node_V1_QueryNodesForProviderRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Sentinel_Node_V1_QueryNodesForProviderResponse>

  func queryNode(request: Sentinel_Node_V1_QueryNodeRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Sentinel_Node_V1_QueryNodeResponse>

  func queryParams(request: Sentinel_Node_V1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Sentinel_Node_V1_QueryParamsResponse>
}

extension Sentinel_Node_V1_QueryServiceProvider {
  internal var serviceName: Substring { return "sentinel.node.v1.QueryService" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "QueryNodes":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Sentinel_Node_V1_QueryNodesRequest>(),
        responseSerializer: ProtobufSerializer<Sentinel_Node_V1_QueryNodesResponse>(),
        interceptors: self.interceptors?.makeQueryNodesInterceptors() ?? [],
        userFunction: self.queryNodes(request:context:)
      )

    case "QueryNodesForProvider":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Sentinel_Node_V1_QueryNodesForProviderRequest>(),
        responseSerializer: ProtobufSerializer<Sentinel_Node_V1_QueryNodesForProviderResponse>(),
        interceptors: self.interceptors?.makeQueryNodesForProviderInterceptors() ?? [],
        userFunction: self.queryNodesForProvider(request:context:)
      )

    case "QueryNode":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Sentinel_Node_V1_QueryNodeRequest>(),
        responseSerializer: ProtobufSerializer<Sentinel_Node_V1_QueryNodeResponse>(),
        interceptors: self.interceptors?.makeQueryNodeInterceptors() ?? [],
        userFunction: self.queryNode(request:context:)
      )

    case "QueryParams":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Sentinel_Node_V1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Sentinel_Node_V1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeQueryParamsInterceptors() ?? [],
        userFunction: self.queryParams(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Sentinel_Node_V1_QueryServiceServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'queryNodes'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeQueryNodesInterceptors() -> [ServerInterceptor<Sentinel_Node_V1_QueryNodesRequest, Sentinel_Node_V1_QueryNodesResponse>]

  /// - Returns: Interceptors to use when handling 'queryNodesForProvider'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeQueryNodesForProviderInterceptors() -> [ServerInterceptor<Sentinel_Node_V1_QueryNodesForProviderRequest, Sentinel_Node_V1_QueryNodesForProviderResponse>]

  /// - Returns: Interceptors to use when handling 'queryNode'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeQueryNodeInterceptors() -> [ServerInterceptor<Sentinel_Node_V1_QueryNodeRequest, Sentinel_Node_V1_QueryNodeResponse>]

  /// - Returns: Interceptors to use when handling 'queryParams'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeQueryParamsInterceptors() -> [ServerInterceptor<Sentinel_Node_V1_QueryParamsRequest, Sentinel_Node_V1_QueryParamsResponse>]
}
